unit formatdisk;

(* TFormatDrive by Markus Stephany (c) 97

this component is used to format a floppy (or a hd) under windows 95/delphi 2.01
it wraps the explorer's SHFormatDrive-dialog

freeware, no limitations (except of the copyright), no guaranties, no fee... just enjoy.

contact:
mirbir.st@t-online.de
mirbir.st@saargate.de
http://home.t-online.de/home/mirbir.st/

revision 0.1 - initial release 08/23/97*)




interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type TFormatOptions = (foQuick,foNormal,foSystem);

type
  TFormatDrive = class(TComponent)
  private
    { Private-Deklarationen }
    fopts : tformatoptions;
    fdrive : char;
    fallowhd : boolean;
    ferror : integer;
    fwnd : hwnd;
  protected
    { Protected-Deklarationen }
  public
    { Public-Deklarationen }
    constructor create(aowner:tcomponent) ; override;
    function Execute : boolean;
             // starts the formatting-dialog
    property Error : integer read ferror;
  published
    { Published-Deklarationen }
    property DefaultAction : TFormatOptions read fopts write fopts;
             // indicates the default-choosen action to perfomr
             // quick-format,normal format or copying of the sys-files
    property Drive : char read fdrive write fdrive;
             // the drive [a..z] to be formatted
    property AllowHD : boolean read fallowhd write fallowhd;
             // switches whether hard-drives can be formatted or not (for security)
  end;

const
     FDE_Invalid_Drive_Type = -100;
     FDE_No_Disk_In_Drive = -101;
     FDE_HD_Not_Allowed = -102;

procedure Register;

function SHFormatDrive (wnd:hwnd;drive:integer;size:uint;action:integer):integer; stdcall; external
         'shell32' name 'SHFormatDrive';

// wnd : the handle of the owner-window for the format-dialog
// drive : 0=a, 1=b ...
// size : ? seems not to be implemented
{  action :
            0 : quick - format (destroys only the fat)
            1 : normal formatting
            2 : "sys x:"}
// result : the result should be 0 if the function was successfull, but it seems that
//          error # 6 (= error_invalid_handle) is returned on success




implementation

procedure Register;
begin
  RegisterComponents('System', [TFormatDrive]);
end;

// constructor
constructor tformatdrive.create(aowner:tcomponent) ;
begin
     inherited;
     fopts := foquick;
     drive := 'a';
     allowhd := false;
     ferror := 0;
     fwnd := 0;
     if aowner is twincontrol then fwnd := (aowner as twincontrol).handle;
end;

// execute
function tformatdrive.execute : boolean;
var i : integer;
    sr : tsearchrec;
begin
     ferror := 0;
     result := false;
     // check drivetype (only floppy (and  maybe hd) are allowed)
     i:= getdrivetype(pchar(drive+':\'));
     case i of
          0,1,drive_remote,drive_cdrom,drive_ramdisk : begin
                                                            ferror := FDE_Invalid_Drive_Type;
                                                            exit;
                                                       end;
     end;
     // check whether hd is allowed
     if i = drive_fixed then if not fallowhd then begin
        ferror := fde_hd_not_allowed;
        exit;
     end;
     // check if disk is inserted into drive
     if i = drive_removable then begin
        fillchar(sr,sizeof(tsearchrec),0);
        i := findfirst(drive+':\*.*',faanyfile,sr);
        findclose(sr);
        if (i = 3) or (i=21) then begin
           ferror := fde_no_disk_in_drive;
           exit;
        end;
     end;

     //now let us start the shformatdrive-api
     ferror:=SHFormatDrive (fwnd,ord(upcase(drive))-ord('A'),0,integer(fopts));
     if ferror = 6 then ferror := 0; // what happens here with error_invalid_handle ?
     result := (ferror = 0);

end;

end.
